SPEAKWELL
from ZX Computing, December'84/January'85

ASSEMBLY LISTING

  10  ;         RECORD MODE
  20            ORG  32768
  30            DI                 ;DISABLE MASKABLE INTERRUPT
  40            LD   HL,(START)    ;START ADDRESS OF DATA INTO HL
  50            LD   DE,(LENGTH)   ;DATA LENGTH INTO DE
  60  LOOP      LD   B,8           ;B CONTROLS LOOP OF 8 BITS/1 BYTE
  70            LD   C,0           ;C COUNTS NO. OF BITS AT EAR PORT
  80            LD   (O),BC        ;TIME WASTING INSTRUCTION
  90  LOOP_2    XOR  A             ;CLEAR A AND CARRY FLAG
 100            IN   A,(254)       ;READ PORT 254
 110            RLA                ;VALUE AT EAR PORT...
 120            RLA                ;ROTATED...
 130            RL   C             ;INTO REGISTER C
 140            DJNZ LOOP_2        ;GET 8 BITS FROM EAR PORT INTO C
 150            LD   (HL),C        ;STORE THE 8 BITS IN (HL)
 160            LD   A,(SPEED)     ;RECORD/PLAY SPEED INTO A
 170            LD B,A             ;USE B TO CONTROL THE LOOP
 180  WAIT      DJNZ WAIT          ;WAIT A SHORT WHILE
 190            INC  HL            ;NEXT LOCATION FOR NEXT 8 BITS
 200            LD   A,D           ;CHECK WHETHER OR NOT...
 210            OR   E             ;TO FETCH ANOTHER 8 BITS
 220            DEC  DE            ;DECREMENT THE COUNT
 230            JR   NZ,LOOP       ;LOOP IF COUNT NOT ZERO
 240            EI                 ;REENABLE THE MASKABLE INTERRUPT...
 250            RET                ;FOR RETURN TO BASIC
 260
 270
 280  ;         PLAYBACK
 290            DI
 300            LD   HL,(START)
 310            LD   DE,(LENGTH)
 320  P_LOOP    LD   B,8           ;B CONTROLS LOOP OF 8 BITS/1 BYTE
 330            LD   C,(HL)        ;GET DATA BYTE TO BE PLAYED
 340            RRC  C             ;GET THE BITS IN THE RIGHT ORDER
 350            RRC  C
 360            RRC  C
 370  P_LP_2    LD   A,C           ;GET THE DATA BYTE INTO A
 380            AND  %00010000     ;MASK THE ONLY REQUIRED BIT
 390            OUT  (254),A       ;OUTPUT THIS BIT TO THE SPEAKER
 400            RLC  C             ;GET NEXT BIT INTO REQUIRED POSITION
 410            DJNZ P_LP_2        ;OUTPUT 8 BITS (1 BYTE)
 420            LD   A,(SPEED)     ;SPEED INTO A
 430            LD   B,A           ;TRANSFER TO B FOR PAUSE
 440  PAUSE     DJNZ PAUSE         ;WAIT A SHORT WHILE
 450            RES  0,A           ;ANOTHER TIME WASTING INSTRUCTION
 460            INC  HL            ;INCREMENT DATA ADDRESS
 470            LD   A,D           ;CHECK TO SEE IF COUNT IS ZERO YET
 480            OR   E
 490            DEC  DE            ;DECREASE THE COUNT BY 1
 500            JR   NZ,P_LOOP     ;LOOP IF COUNT NOT ZERO
 510            EI                 ;RE-ENABLE MASKABLE INTERRUPT...
 520            RET                ;FOR RETURN TO BASIC
 530  START     DEFW 32855         ;START ADDRESS OF SPEECH DATA
 540  LENGTH    DEFW 32512         ;LENGTH OF SPEECH DATA
 550  SPEED     DEFB 1             ;RECORD/PLAY SPEED
